SystemOrganization addCategory: #'Seaside-Pharo-Gettext-Core'!

!GRPackage class methodsFor: '*seaside-pharo-gettext-core' stamp: 'pmm 5/29/2011 09:50'!
seasidePharoGettextCore
	^ self new
		name: 'Seaside-Pharo-Gettext-Core';
		description: 'i18n and l10n using gettext';
		url: #seasideAddonsUrl;
		yourself! !

GetTextExporter subclass: #WAGetTextExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Gettext-Core'!

!WAGetTextExporter methodsFor: 'exporting' stamp: 'JohanBrichau 3/1/2014 14:21'!
appendStringReceiversInto: domains
	| found |
	
	found := WATranslatedArgumentsFinder new translatedArguments.
	found do: [ :assoc |
		| literals domainName methodReference keywords |
		methodReference := assoc key.
		keywords := assoc value.
		domainName := self getTextDomainForClassCategory: methodReference realClass category.
		literals := domains at: domainName ifAbsentPut: [ Dictionary new ].
		keywords do: [ :literal |
			| references |
			references := literals at: literal ifAbsentPut: [ OrderedCollection new ].
			references add: methodReference ] ]. 
! !

!WAGetTextExporter methodsFor: 'exporting' stamp: 'JohanBrichau 3/1/2014 14:58'!
appendTranslations: domains
	"The Seaside translation messages are fixed"
	self appendStringReceiversInto: domains! !

!WAGetTextExporter methodsFor: 'exporting' stamp: 'JohanBrichau 3/1/2014 14:57'!
appendTranslations: domains for: someSelectors
	"The Seaside translation messages are fixed"
	self appendStringReceiversInto: domains! !

WAObject subclass: #WATranslatedArgumentsFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Gettext-Core'!

!WATranslatedArgumentsFinder methodsFor: 'accessing' stamp: 'JohanBrichau 3/1/2014 10:36'!
translatedArguments
	"self new translatedArguments"
	| searcher currentClass result innerMatchHandler extractFirstArgument extractReceiver |
	currentClass := WAValueHolder with: nil.
	result := GROrderedMultiMap new.
	innerMatchHandler := [ :node :literal |
		| key |
		key := RGMethodDefinition
			class: currentClass contents
			selector: node methodNode selector.
			result at: key add: literal value ].
	extractFirstArgument := [ :node :answer |
		| firstArgument |
		firstArgument := node arguments first.
		firstArgument isLiteralNode ifTrue: [
			innerMatchHandler value: node value: firstArgument ] ].
	extractReceiver := [ :node :answer |
		node receiver isLiteralNode ifTrue: [
			innerMatchHandler value: node value: node receiver ] ].
	searcher := RBParseTreeSearcher new
		matches: '`@object translate: `#string' do: extractFirstArgument;
		matches: '`@object translate: `#string to: `@arg' do: extractFirstArgument;
		matches: '`#string seasideTranslated' do: extractReceiver;
		matches: '`#string seasideLazyTranslated' do: extractReceiver;
		matches: '`#string seasideTranslatedTo: `@arg' do: extractReceiver;
		yourself.
	RBBrowserEnvironment new classesAndSelectorsDo: [ :class :selector |
		(searcher canMatchMethod: class >> selector) ifTrue: [
		| tree |
		(tree := class parseTreeFor: selector) notNil ifTrue: [
			currentClass contents: class.
			searcher executeTree: tree ] ] ].
	^ Array streamContents: [ :stream |
		result keysDo: [ :key |
			stream nextPut: key -> (result allAt: key) ] ]! !
